<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="年度" prop="year">
        <el-input
          v-model="queryParams.year"
          placeholder="请输入年度"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="院校id" prop="universityId">
        <el-input
          v-model="queryParams.universityId"
          placeholder="请输入院校id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="专业科目" prop="subjects">
        <el-input
          v-model="queryParams.subjects"
          placeholder="请输入专业科目"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="适用省份" prop="locations">
        <el-input
          v-model="queryParams.locations"
          placeholder="请输入适用省份"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="适用考生类型" prop="examineeTypes">
        <el-input
          v-model="queryParams.examineeTypes"
          placeholder="请输入适用考生类型"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="总分" prop="score">
        <el-input
          v-model="queryParams.score"
          placeholder="请输入总分"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="时长" prop="time">
        <el-input
          v-model="queryParams.time"
          placeholder="请输入时长"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['learn:learnCultureKnowledge:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['learn:learnCultureKnowledge:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['learn:learnCultureKnowledge:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['learn:learnCultureKnowledge:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="learnCultureKnowledgeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="年度" align="center" prop="year" />
      <el-table-column label="院校id" align="center" prop="universityId" />
      <el-table-column label="专业科目" align="center" prop="subjects" />
      <el-table-column label="题型分布" align="center" prop="questionTypes" />
      <el-table-column label="知识点列表" align="center" prop="knowledges" />
      <el-table-column label="适用省份" align="center" prop="locations" />
      <el-table-column label="适用考生类型" align="center" prop="examineeTypes" />
      <el-table-column label="总分" align="center" prop="score" />
      <el-table-column label="时长" align="center" prop="time" />
      <el-table-column label="仿真模拟卷要求" align="center" prop="conditions" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['learn:learnCultureKnowledge:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['learn:learnCultureKnowledge:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改文化知识点关系对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="learnCultureKnowledgeRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="年度" prop="year">
          <el-input v-model="form.year" placeholder="请输入年度" />
        </el-form-item>
        <el-form-item label="院校id" prop="universityId">
          <el-input v-model="form.universityId" placeholder="请输入院校id" />
        </el-form-item>
        <el-form-item label="专业科目" prop="subjects">
          <el-input v-model="form.subjects" placeholder="请输入专业科目" />
        </el-form-item>
        <el-form-item label="题型分布" prop="questionTypes">
          <el-input v-model="form.questionTypes" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="知识点列表" prop="knowledges">
          <el-input v-model="form.knowledges" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="适用省份" prop="locations">
          <el-input v-model="form.locations" placeholder="请输入适用省份" />
        </el-form-item>
        <el-form-item label="适用考生类型" prop="examineeTypes">
          <el-input v-model="form.examineeTypes" placeholder="请输入适用考生类型" />
        </el-form-item>
        <el-form-item label="总分" prop="score">
          <el-input v-model="form.score" placeholder="请输入总分" />
        </el-form-item>
        <el-form-item label="时长" prop="time">
          <el-input v-model="form.time" placeholder="请输入时长" />
        </el-form-item>
        <el-form-item label="仿真模拟卷要求" prop="conditions">
          <el-input v-model="form.conditions" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LearnCultureKnowledge">
import { listLearnCultureKnowledge, getLearnCultureKnowledge, delLearnCultureKnowledge, addLearnCultureKnowledge, updateLearnCultureKnowledge } from "@/api/learn/learnCultureKnowledge"

const { proxy } = getCurrentInstance()

const learnCultureKnowledgeList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    year: null,
    universityId: null,
    subjects: null,
    questionTypes: null,
    knowledges: null,
    locations: null,
    examineeTypes: null,
    score: null,
    time: null,
    conditions: null
  },
  rules: {
    year: [
      { required: true, message: "年度不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询文化知识点关系列表 */
function getList() {
  loading.value = true
  listLearnCultureKnowledge(queryParams.value).then(response => {
    learnCultureKnowledgeList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    year: null,
    universityId: null,
    subjects: null,
    questionTypes: null,
    knowledges: null,
    locations: null,
    examineeTypes: null,
    score: null,
    time: null,
    conditions: null
  }
  proxy.resetForm("learnCultureKnowledgeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加文化知识点关系"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getLearnCultureKnowledge(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改文化知识点关系"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["learnCultureKnowledgeRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateLearnCultureKnowledge(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addLearnCultureKnowledge(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除文化知识点关系编号为"' + _ids + '"的数据项？').then(function() {
    return delLearnCultureKnowledge(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/learnCultureKnowledge/export', {
    ...queryParams.value
  }, `learnCultureKnowledge_${new Date().getTime()}.xlsx`)
}

getList()
</script>
